//App created by: David Gonzalez Morte - TFC UOC

package com.example.theandroidseek;




import java.util.ArrayList;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient.ConnectionCallbacks;
import com.google.android.gms.common.GooglePlayServicesClient.OnConnectionFailedListener;
import com.google.android.gms.location.LocationClient;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.PolylineOptions;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;

/*
 * Aquesta classe ens mostrar un mapa de google amb la nostra situaci actual.
 * S'ha extret informaci tant de:
 * https://developers.google.com/maps/documentation/android/start
 * com dels exemples facilitats a les llibreries de google
 */

/**
 * 
 * Afegir, que en aquesta classe, s on es donara acci a les opcions que apareixeran en 
 * el submen del dispositiu mbil.2
 *
 */

public class CercaLlocInteres extends FragmentActivity implements ConnectionCallbacks, OnConnectionFailedListener, LocationListener{	

	private GoogleMap mMap;
	private LocationClient mLocationClient;
    private int TipusCanviat=1;
    private String tipus=null;
    private String nomRuta=null;
    public static final int TIME_ENTRY_REQUEST_CODE=1;
    PuntsInteresAdapter puntsInteresAdapter;
    private ArrayList<PuntsInteresClass> punts;
    private RecorregutsClass rutes;
    RecorregutsAdapter recorregutsAdapter;
    boolean esVolRutes=false;
    boolean marcaCompass=false;
    boolean Conexio=true;
	
	  private static final LocationRequest REQUEST = LocationRequest.create()
		      .setInterval(5000)         
		      .setFastestInterval(16)   
		      .setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
	  
	@Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.cerca_lloc_interes);
        mLocationClient = new LocationClient(this, this, this);
        setUpMapIfNeeded();
    }
	
   protected void onResume() {
        super.onResume();
        setUpMapIfNeeded();
        setUpLocationClientIfNeeded();
        mLocationClient.connect();
    }
    
    
    private void setUpMapIfNeeded() {
        if (mMap == null) {   
            mMap = ((SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map)).getMap();
            if (mMap != null) {
            	mMap.setMyLocationEnabled(true);
            }
        }
    }
    
    private void setUpLocationClientIfNeeded() {
        if (mLocationClient == null) {
          mLocationClient = new LocationClient(
              getApplicationContext(),
              this,  
              this); 
        }
      }
   

    private void setUpMap() {
    	int posicio=0; 
    	mMap.clear();
        LocationManager locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        Criteria criteria = new Criteria();
        String provider = locationManager.getBestProvider(criteria, true);
        Location myLocation = locationManager.getLastKnownLocation(provider);
        mMap.setMapType(mMap.MAP_TYPE_NORMAL);
        if(TipusCanviat==1){ mMap.setMapType(mMap.MAP_TYPE_NORMAL);}
        if(TipusCanviat==2){ mMap.setMapType(mMap.MAP_TYPE_HYBRID);}
        if(TipusCanviat==3){ mMap.setMapType(mMap.MAP_TYPE_SATELLITE);}
        if(TipusCanviat==4){ mMap.setMapType(mMap.MAP_TYPE_TERRAIN);}

        if(Conexio==false){
        	LatLng latlng = new LatLng(myLocation.getLatitude(),myLocation.getLongitude());
        	mMap.moveCamera(CameraUpdateFactory.newLatLng(latlng));
        	mMap.animateCamera(CameraUpdateFactory.zoomTo(15));	
        	mMap.addMarker(new MarkerOptions().position(new LatLng(myLocation.getLatitude(), myLocation.getLongitude())).title("Jo estic aqu"));
        }

        if(Conexio=true){
        Location my2Location = mLocationClient.getLastLocation();
        mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(new LatLng(my2Location.getLatitude(), my2Location.getLongitude()),15));
	    mMap.addMarker(new MarkerOptions().position(new LatLng(my2Location.getLatitude(), my2Location.getLongitude())).title("Jo estic aqu"));}
      
        if(tipus!=null){
        mMap.animateCamera(CameraUpdateFactory.zoomTo(12));	
        }
        
        if(tipus!=null){
    	   while(posicio<punts.size()){
    		   String text = punts.get(posicio).getTipus()+" "+punts.get(posicio).getNom()+" "+punts.get(posicio).getTelf();
    		   mMap.addMarker(new MarkerOptions().position(new LatLng(punts.get(posicio).getLat(),
    				   punts.get(posicio).getLng())).title(punts.get(posicio).getNom()).snippet("Telf: "+punts.get(posicio).getTelf()));
    		   posicio++;
    	   }}
       
    	  
       if(nomRuta!=null){
    	       mMap.clear();
    	       mMap.moveCamera(CameraUpdateFactory.newLatLng(rutes.getPuntA()));
    	       mMap.animateCamera(CameraUpdateFactory.zoomTo(10));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntA()).title("Punt Inicial"));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntB()).title("Punt B"));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntC()).title("Punt C"));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntD()).title("Punt D"));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntE()).title("Punt E"));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntF()).title("Punt F"));
    		   mMap.addMarker(new MarkerOptions().position(rutes.getPuntG()).title("Punt Final"));
  		  
    	        mMap.addPolyline((new PolylineOptions())
    	                .add(rutes.getPuntA(), rutes.getPuntB(),
    	                		rutes.getPuntC(),rutes.getPuntD(),
    	                		rutes.getPuntE(),rutes.getPuntF(),
    	                		rutes.getPuntG())
    	        		.width(5)
    	        		.color(Color.GREEN));	     
       }
    }
    
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		MenuInflater menuInflater = getMenuInflater();
		menuInflater.inflate(R.menu.menu_cerca_lloc, menu);
		return true;
	}
	
   public boolean onMenuItemSelected(int featureId, MenuItem item){

	   if(item.getItemId()==R.id.botoUbicacions){
		   Intent intent = new Intent(this,Ubicacions.class);
           startActivityForResult(intent, TIME_ENTRY_REQUEST_CODE);	   
		   return true;
	   }
	   
	   if(item.getItemId()==R.id.botoTipusMapa){
		   showTipusMapaDialog();
		   return true;
	   }
	   
	   if(item.getItemId()==R.id.botoNetejaMapa){
		   mMap.clear();
		   tipus=null;
		   nomRuta=null;
		   return true;
	   }
	   
	   if(item.getItemId()==R.id.botoRutes){
		   esVolRutes=true;
		   Intent intent = new Intent(this,NomsDeRutes.class);
           startActivityForResult(intent, TIME_ENTRY_REQUEST_CODE);	
		   mMap.clear();
		   return true;
	   }
	   if(item.getItemId()==R.id.botoActualitzar){
			onResume();
		   tipus=null;
		   nomRuta=null;
		   return true;
	   }

	   
	   return super.onOptionsItemSelected(item);
	   
   }
   
 protected void onActivityResult(int requestCode, int resultCode, Intent data){
	
	 if(requestCode==TIME_ENTRY_REQUEST_CODE){ 
		 if(resultCode==RESULT_OK){	 
			 if(esVolRutes==false){  
			 tipus = data.getStringExtra("tipus");
			   inserirTipus();}
			 if(esVolRutes==true){
				 tipus = data.getStringExtra("tipus");
				 inserirRutes();
				 esVolRutes=false;
			 }
			 
		   }
	   }
   }

   private void inserirTipus() {
	nomRuta=null;
	punts = new ArrayList<PuntsInteresClass>();
	puntsInteresAdapter = new PuntsInteresAdapter();
	int longitud = puntsInteresAdapter.getCount();
	int posicio=0;
	Toast.makeText(getApplicationContext(),""+tipus,Toast.LENGTH_SHORT).show();
	if(tipus!="Mostra Tots"){
	while (posicio<longitud){
		if(puntsInteresAdapter.getTipus(posicio).compareTo(tipus)==0){
			punts.add(puntsInteresAdapter.getItem(posicio));
		}
		posicio++;
	}}
	if(tipus=="Mostra Tots")
	{
		while (posicio<longitud){
				punts.add(puntsInteresAdapter.getItem(posicio));
			posicio++;}
	}

	onResume();
   }
   
   private void inserirRutes(){
	   nomRuta=tipus;
	   Toast.makeText(getApplicationContext(),nomRuta,Toast.LENGTH_SHORT).show();
	   tipus=null;
	   recorregutsAdapter= new RecorregutsAdapter();
	   int longitud = recorregutsAdapter.getCount();
	   int posicio=0;
	   while(posicio<longitud){
		   if(recorregutsAdapter.getTipus(posicio).compareTo(nomRuta)==0){
			   rutes=recorregutsAdapter.getItem(posicio);
		   }
	   posicio++;}
		onResume();
	   
   }
   
	public void showTipusMapaDialog(){
		final String[] tipusMap ={"Normal","Terrain","Satellit","Hybrid"};
		AlertDialog.Builder dialogBuilder=new AlertDialog.Builder(this);
		dialogBuilder.setTitle("Tipus Mapa");
		
		dialogBuilder.setItems(tipusMap, new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				if (tipusMap[which]=="Normal"){
					   TipusCanviat=1;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_NORMAL);
				}
				
				if (tipusMap[which]=="Terrain"){
					   TipusCanviat=4;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_TERRAIN);
				}
				
				if (tipusMap[which]=="Satellit"){
					   TipusCanviat=3;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_SATELLITE);
				}
				
				if (tipusMap[which]=="Hybrid"){
					   TipusCanviat=2;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_HYBRID);
				}
				
			}
		});
		


		AlertDialog alertDialog = dialogBuilder.create();
		alertDialog.show();
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onConnectionFailed(ConnectionResult result) {
		// TODO Auto-generated method stub
		Conexio=false;
	}

	@Override
	public void onConnected(Bundle connectionHint) {
		// TODO Auto-generated method stub
	    mLocationClient.requestLocationUpdates(
	            REQUEST,
	            this); 
	    Conexio=true;
	    setUpMap();
	}

	@Override
	public void onDisconnected() {
		// TODO Auto-generated method stub
		
	}

   	
}