//App created by: David Gonzalez Morte - TFC UOC

package com.example.theandroidseek;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient.ConnectionCallbacks;
import com.google.android.gms.common.GooglePlayServicesClient.OnConnectionFailedListener;
import com.google.android.gms.location.LocationClient;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.telephony.SmsManager;
import android.view.View;
import android.widget.TextView;


public class CercaUsuari extends Activity implements ConnectionCallbacks, OnConnectionFailedListener, LocationListener{	
    private static final int PICK_CONTACT_REQUEST=0;
	private String name=null;
	private String telf=null;
	private Uri contactUri;
	private double latitude;
	private double longitud;
	private String LatLng;
	private LocationClient mLocationClient;
    private ProgressDialog pd=null;
    boolean Conexio=true;
    
    
	  private static final LocationRequest REQUEST = LocationRequest.create()
		      .setInterval(5000)         
		      .setFastestInterval(16)   
		      .setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
	
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.cerca_usuari);
        setUpLocationClientIfNeeded();
        mLocationClient.connect();
        pd=ProgressDialog.show(this,"Localitzant","Esperant coordenades");	
	}
	
    private void setUpLocationClientIfNeeded() {
        if (mLocationClient == null) {
          mLocationClient = new LocationClient(
              getApplicationContext(),
              this, 
              this);
        }
      }

	private void renderContact(Uri uri){
		TextView contactNameView=(TextView) findViewById(R.id.textViewNomContacte);
		TextView contactTelfView=(TextView) findViewById(R.id.textViewTelfContacte);
		TextView contactLatLngView=(TextView) findViewById(R.id.textLatLng);
		LocationManager locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        Criteria criteria = new Criteria();
        String provider = locationManager.getBestProvider(criteria, true);
		Location myLocation = locationManager.getLastKnownLocation(provider);
		if(Conexio==false){
			latitude=myLocation.getLatitude();
			longitud=myLocation.getLongitude();
        LatLng = Double.toString(latitude)+","+Double.toString(longitud);}
		if(Conexio==true){
			Location my2Location = mLocationClient.getLastLocation();
			latitude=my2Location.getLatitude();
			longitud=my2Location.getLongitude();
			LatLng = Double.toString(latitude)+","+Double.toString(longitud);
		}
        if(uri==null){
			
		}else{
			contactNameView.setText(getDisplayName(uri));
			contactTelfView.setText(getMobileNumber(uri));
			contactLatLngView.setText(LatLng);
		}
		
	}
	
	public void onUpdateContact(View view){
		startActivityForResult(
				new Intent(
						Intent.ACTION_PICK, ContactsContract.Contacts.CONTENT_URI
						),
		PICK_CONTACT_REQUEST
		);
	}
	
	protected void onActivityResult(int requestCode, int resultCode, Intent intent){
		if(requestCode==PICK_CONTACT_REQUEST){
			if(resultCode==RESULT_OK){
				contactUri=intent.getData();
				renderContact(intent.getData());
			}
		}
	}
	
	private String getDisplayName(Uri uri){
		Cursor cursor=getContentResolver().query(uri,null,null,null,null);
		if(cursor.moveToFirst()){
			name=cursor.getString(cursor.getColumnIndex
					(ContactsContract.Contacts.DISPLAY_NAME));
			
		}	
		
		return name;}
	
	
	private String getMobileNumber(Uri uri){
		
		Cursor contactCursor=getContentResolver().query(uri,
				new String[]{ContactsContract.Contacts._ID}, 
				null,null, null);
		String id=null;
		
		if(contactCursor.moveToFirst()){
			id=contactCursor.getString(
					contactCursor.getColumnIndex(ContactsContract.Contacts._ID));
		}
		contactCursor.close();
		
		Cursor phoneCursor=getContentResolver().query(
				ContactsContract.CommonDataKinds.Phone.CONTENT_URI, 
				new String[]{ContactsContract.CommonDataKinds.Phone.NUMBER}, 
				ContactsContract.CommonDataKinds.Phone.CONTACT_ID+"=?",
				new String[]{id}, 
				null);
		if(phoneCursor.moveToFirst()){
			telf=phoneCursor.getString(phoneCursor.getColumnIndex
					(ContactsContract.CommonDataKinds.Phone.NUMBER));
		}
      phoneCursor.close();
		
		
		return telf;}
	
	public void onEnviarSenyal(View view){

		if(telf!=null){
			showEnviarSenyalDialog();
		}
		else{
			showNohihaTelfDialog();
		}

	}

	public void onTreureSenyal(View view){
		if(telf!=null){
			showTreureSenyalDialog();
		}
		else{
			showNohihaTelfDialog();
		}	
		
	}
	
	public void showEnviarSenyalDialog(){
		AlertDialog.Builder dialogBuilder=new AlertDialog.Builder(this);
		dialogBuilder.setTitle("Enviar senyal de perdut");
		dialogBuilder.setMessage("Segur que vols enviar el senyal de perdut a " + name +" ?");
		dialogBuilder.setPositiveButton("Continuar", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				SmsManager smsManager = SmsManager.getDefault();
				smsManager.sendTextMessage(
						telf, 
						null, 
						"M'he perdut. Coordenades ="+ LatLng, 
						null, 
						null);
				
			}
		});
		
		dialogBuilder.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				
			}
		});
		
		AlertDialog alertDialog = dialogBuilder.create();
		alertDialog.show();
	}
	
	public void showTreureSenyalDialog(){
		AlertDialog.Builder dialogBuilder=new AlertDialog.Builder(this);
		dialogBuilder.setTitle("Treure senyal de perdut");
		dialogBuilder.setMessage("Segur que vols indicar que ja no estas perdut a " + name +" ?");
		dialogBuilder.setPositiveButton("Continuar", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				SmsManager smsManager = SmsManager.getDefault();
				smsManager.sendTextMessage(
						telf, 
						null, 
						"Ja no estic perdut", 
						null, 
						null);
				
			}
		});
		
		dialogBuilder.setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				
			}
		});
		
		AlertDialog alertDialog = dialogBuilder.create();
		alertDialog.show();
	}
	
	public void showNohihaTelfDialog(){
		AlertDialog.Builder dialogBuilder=new AlertDialog.Builder(this);
		dialogBuilder.setTitle("Advertncia");
		dialogBuilder.setMessage("Per enviar senyal has d'indicar un contacte");
		dialogBuilder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {			
			}
		});

		AlertDialog alertDialog = dialogBuilder.create();
		alertDialog.show();
	}
	
	public void onUbicarUsuari(View view){
	
		Intent intent = new Intent(this,IntroCoord.class);
		startActivity(intent);	
		
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onConnectionFailed(ConnectionResult result) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onConnected(Bundle connectionHint) {
		// TODO Auto-generated method stub
	    mLocationClient.requestLocationUpdates(
	            REQUEST,
	            this); 
	    pd.dismiss();
	    Conexio=true;
	}

	@Override
	public void onDisconnected() {
		// TODO Auto-generated method stub
		pd.dismiss();
		Conexio=false;
	}	
	
}