//App created by: David Gonzalez Morte - TFC UOC

package com.example.theandroidseek;




import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient.ConnectionCallbacks;
import com.google.android.gms.common.GooglePlayServicesClient.OnConnectionFailedListener;
import com.google.android.gms.location.LocationClient;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.PolylineOptions;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

/*
 * Aquesta classe ens mostrar un mapa de google amb la nostra situaci actual.
 * S'ha extret informaci tant de:
 * https://developers.google.com/maps/documentation/android/start
 * com dels exemples facilitats a les llibreries de google
 */

public class MostrarUsuariPerdut extends FragmentActivity implements ConnectionCallbacks, OnConnectionFailedListener, LocationListener{		

	private GoogleMap mMap;
    private int TipusCanviat=1;
    public static final int TIME_ENTRY_REQUEST_CODE=1;
    public double Lat;
    public double Lng;
    public Location LocationA;
    public Location LocationB;
    float distancia=0;
	private LocationClient mLocationClient;
    boolean Conexio=true;

	
	  private static final LocationRequest REQUEST = LocationRequest.create()
		      .setInterval(5000)         
		      .setFastestInterval(16)   
		      .setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
	  
	@Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mapa_mostra_usuari_perdut);
        mLocationClient = new LocationClient(this, this, this);

    }
	
	   protected void onResume() {
	        super.onResume();
	        setUpMapIfNeeded();
	        setUpLocationClientIfNeeded();
	        mLocationClient.connect();

	    }
    
    private void setUpLocationClientIfNeeded() {
        if (mLocationClient == null) {
          mLocationClient = new LocationClient(
              getApplicationContext(),
              this,  
              this); 
        }
      }
    
    private void setUpMapIfNeeded() {
        
        if (mMap == null) {   
            mMap = ((SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map2)).getMap();
            if (mMap != null) {
            	mMap.setMyLocationEnabled(true);
            }
        }
    }
    

    private void setUpMap() {
    	Intent intent=getIntent();
    	mMap.setMyLocationEnabled(true);
        LocationManager locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        Criteria criteria = new Criteria();
        String provider = locationManager.getBestProvider(criteria, true);
        Location myLocation = locationManager.getLastKnownLocation(provider);
        LocationA=myLocation;
        mMap.setMapType(mMap.MAP_TYPE_NORMAL);
        if(TipusCanviat==1){ mMap.setMapType(mMap.MAP_TYPE_NORMAL);}
        if(TipusCanviat==2){ mMap.setMapType(mMap.MAP_TYPE_HYBRID);}
        if(TipusCanviat==3){ mMap.setMapType(mMap.MAP_TYPE_SATELLITE);}
        if(TipusCanviat==4){ mMap.setMapType(mMap.MAP_TYPE_TERRAIN);}
        Lat=Double.parseDouble(intent.getStringExtra("Lat"));
        Lng=Double.parseDouble(intent.getStringExtra("Lng"));
        //LatLng latlngJo = new LatLng(myLocation.getLatitude(),myLocation.getLongitude());
        LatLng latlngJo=null;
		if(Conexio==false){
			 latlngJo = new LatLng(myLocation.getLatitude(),myLocation.getLongitude());}
			if(Conexio==true){
				Location my2Location = mLocationClient.getLastLocation();
				LocationA=my2Location;
				 latlngJo = new LatLng(my2Location.getLatitude(),my2Location.getLongitude());
			}
        LatLng latlng = new LatLng(Lat,Lng);
        mMap.moveCamera(CameraUpdateFactory.newLatLng(latlng));
        mMap.animateCamera(CameraUpdateFactory.zoomTo(12));
        mMap.addMarker(new MarkerOptions().position(latlng).title("Usuari Perdut"));    
        mMap.addMarker(new MarkerOptions().position(latlngJo).title("Jo estic aqu"));
        mMap.addPolyline((new PolylineOptions())
                .add(latlng, latlngJo)
        		.width(5)
        		.color(Color.GREEN));
    }
    
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	
		super.onCreateOptionsMenu(menu);
		MenuInflater menuInflater = getMenuInflater();
		menuInflater.inflate(R.menu.info_ubicacio_usuari, menu);
		return true;
	}
	
   public void distanciaEntrePunts(){

		   LocationB=new Location("Punt B");
		   LocationB.setLatitude(Lat);
		   LocationB.setLongitude(Lng);
		   distancia=LocationA.distanceTo(LocationB);
		   distancia=distancia/1000;
	   }
	
   public boolean onMenuItemSelected(int featureId, MenuItem item){


	   if(item.getItemId()==R.id.botoInfoUbicacioUsuari){
		   distanciaEntrePunts();
		   MostrarUsuariPerdut.this.showDialog(0);
		   return true;
		
	   }
	   
	   if(item.getItemId()==R.id.botoTipusMapa){
		   showTipusMapaDialog();
		   return true;
	   }
	   
	   return super.onOptionsItemSelected(item);
	   
   }
   
	
	protected Dialog onCreateDialog(int id){
		Dialog dialog=new Dialog(this);
		dialog.setContentView(R.layout.custom_dialog);
		dialog.setTitle("Informaci");
		

		TextView textView = (TextView)dialog.findViewById(R.id.usuari_distancia);
		textView.setText("Distancia fins l'usuari: "+ distancia + " km");
		
		double tempsApeu= distancia/4;
		tempsApeu=Math.round(tempsApeu*1000)/1000.000;
		TextView textView2 = (TextView)dialog.findViewById(R.id.usuari_temps_a_peu);
		textView2.setText("Es triguen "+tempsApeu+" hores caminant");
		
		TextView textView3 = (TextView)dialog.findViewById(R.id.usuari_temps_en_bicicleta);
		double tempsABici= distancia/25;
		tempsABici=Math.round(tempsABici*1000)/1000.000;
		textView3.setText("Es triguen "+tempsABici+" hores en bici");
		
		TextView textView4 = (TextView)dialog.findViewById(R.id.usuari_temps_en_cotxe);
		double tempsACotxe= distancia/90;
		tempsACotxe=Math.round(tempsACotxe*1000)/1000.000;
		textView4.setText("Es triguen "+ tempsACotxe +" hores en cotxe");
		
		return dialog;
		
	}
	
	public void showTipusMapaDialog(){
		final String[] tipusMap ={"Normal","Terrain","Satellit","Hybrid"};
		AlertDialog.Builder dialogBuilder=new AlertDialog.Builder(this);
		dialogBuilder.setTitle("Tipus Mapa");
		
		dialogBuilder.setItems(tipusMap, new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				if (tipusMap[which]=="Normal"){
					   TipusCanviat=1;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_NORMAL);
				}
				
				if (tipusMap[which]=="Terrain"){
					   TipusCanviat=4;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_TERRAIN);
				}
				
				if (tipusMap[which]=="Satellit"){
					   TipusCanviat=3;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_SATELLITE);
				}
				
				if (tipusMap[which]=="Hybrid"){
					   TipusCanviat=2;
					   setUpMapIfNeeded();
					   mMap.setMapType(mMap.MAP_TYPE_HYBRID);
				}
				
			}
		});
		


		AlertDialog alertDialog = dialogBuilder.create();
		alertDialog.show();
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onConnectionFailed(ConnectionResult result) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onConnected(Bundle connectionHint) {
		// TODO Auto-generated method stub
	    mLocationClient.requestLocationUpdates(
	            REQUEST,
	            this); 
	    Conexio=true;
	    setUpMap();
	}

	@Override
	public void onDisconnected() {
		// TODO Auto-generated method stub
		Conexio=false;
	}
   
} 	

