//App created by: David Gonzalez Morte - TFC UOC

package com.example.theandroidseek;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;


public class TelefonsBD{
	private static final int DATABASE_VERSION=1;
	private static final String DATABASE_NAME="telefonsBD.db";
	private static final String TABLE_NAME="telfrecords";
	public static final String KEY_ID="_id";
	public static final String KEY_NOM="nom";
	public static final String KEY_TELEFON="telefon";
	private static final String CREAR_BD="CREATE TABLE telfrecords (id integer primary key, nom text not null, telefon text not null)";
	private SQLiteDatabase db;
	private TelefonsBDHelper BDHelper;
	private final Context context;
		
	
	public TelefonsBD(Context ctx) {
		this.context=ctx;
		BDHelper=new TelefonsBDHelper(context);
		// TODO Auto-generated constructor stub
	}
	public class TelefonsBDHelper extends SQLiteOpenHelper {



		 TelefonsBDHelper (Context context){
			
			 super(context,DATABASE_NAME,null,DATABASE_VERSION);
		}

		@Override
		public void onCreate(SQLiteDatabase db) {
			// TODO Auto-generated method stub
			try{
				db.execSQL(CREAR_BD);
			}catch(SQLException e){
				e.printStackTrace();
			}
			
		}

		@Override
		public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
			// TODO Auto-generated method stub
			db.execSQL("DROP TABLE IF EXISTS telfrecords");
			onCreate(db);
		}

		}
	
	public TelefonsBD abrir()throws SQLException{
		db=BDHelper.getWritableDatabase();
		return this;
	}
	
	public void cerrar(){
		BDHelper.close();
	}
	
	public long insertarTelf(String nom,String telefon){
		ContentValues valoresIniciales = new ContentValues();
		valoresIniciales.put(KEY_NOM,nom);
		valoresIniciales.put(KEY_TELEFON,telefon);
		return db.insert(TABLE_NAME,null,valoresIniciales);
	}
	
	public boolean borrarContacto(long idFila){
		return db.delete(TABLE_NAME,KEY_ID + "="+idFila,null)>0;
	}

	public Cursor obtenerTodosLosContactos(){
		return db.rawQuery("SELECT * FROM"+TABLE_NAME,null);
		
	}
	
	
	
}